function firstRegistListener(obj) {
	obj.btn_start_mc.addEventListener('click', obj, false);
	obj.btn_start_mc.addEventListener('touchstart', obj, false);
	obj.btn_inputpass_mc.addEventListener('click', obj, false);
	obj.btn_inputpass_mc.addEventListener('touchstart', obj, false);
	obj.btn_sound_mc.addEventListener('click', obj, false);
	obj.btn_sound_mc.addEventListener('touchstart', obj, false);
	obj.dummy_mc.addEventListener('click', obj, false);
	obj.dummy_mc.addEventListener('touchstart', obj, false);
	obj.btn_change_name_mc.addEventListener('click', obj, false);
	obj.btn_change_name_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_start_mc") {
	      		onStart(obj);
	        } else if(event.target.parent.name == "btn_inputpass_mc") {
	        	var inputPass = prompt("パスワードを入力することでその時のデータから開始できます。(現在のデータは消去されます)", "");
	        	if(inputPass != undefined && inputPass != null && inputPass != "") {
	        		//changeCegUserName(CEG_AID, obj.cegSessionKey, inputName, obj);
	        		changeCegAccount(inputPass, obj);
	        	}
	        } else if(event.target.parent.name == "btn_sound_mc") {
	        	changeSoundFlg(obj);
	        } else if(event.target.parent.name == "btn_ranking_mc") {
	        	location.href = "ranking.html";
	        } else if(event.target.parent.name == "btn_tweet_mc" && obj.gameFinishFlg) {
	        	onTweet(obj);
	        } else if(event.target.parent.name == "btn_change_name_mc") {
	        	var inputName = prompt("名前を入力してください", obj.cegUserName);
	        	if(inputName != undefined && inputName != null && inputName != "") {
	        		changeCegUserName(CEG_AID, obj.cegSessionKey, inputName, obj);
	        	}
	        } else {
	        }
	        break;
	    }
	};
}

function onStart(obj) {
	//2フレームへ
	obj.gotoAndStop(2);
	
	//ゲーム画面初期化
	formatGameDisplay(obj);

	//タイマー開始
	obj.intervalId = setInterval(onFrame, INTERVAL, obj);
	obj.autoSaveId = setInterval(onAutoSave, AUTOSAVE_INTERVAL, obj);
}

function closeAd() {
	document.getElementById("interAd").style.display = "none";
}

function closeLink() {
	document.getElementById("interLink").style.display = "none";
}

//ゲーム中のframe
function onFrame(obj) {
	//自動クリック
	exeAutoClick(obj);

	//カンスト
	exeCountStop(obj);

	//アイテムカウントダウン
	exeItemCountDown(obj);
}

function onAutoSave(obj) {
	obj.autoSaveFlg = true;
	saveValueLocalAndServer(obj);

	//広告リロード
	reloadFooter(obj);

	//アイテムorインステ表示 
	displayInterItem(obj);


}

//アリスのリスナー
function addCharaListener(obj) {
	obj.chara_mc.addEventListener('click', obj, false);
	obj.chara_mc.addEventListener('touchstart', obj, false);
	obj.button_shop_mc.addEventListener('click', obj, false);
	obj.button_shop_mc.addEventListener('touchstart', obj, false);
	obj.button_menu_mc.addEventListener('click', obj, false);
	obj.button_menu_mc.addEventListener('touchstart', obj, false);
	obj.button_save_mc.addEventListener('click', obj, false);
	obj.button_save_mc.addEventListener('touchstart', obj, false);
	obj.dummy3.addEventListener('click', obj, false);
	obj.dummy3.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "chara_mc") {
	      		//アリスタッチ処理へ
	      		touchChara(obj);
			} else if(event.target.parent.name == "button_shop_mc") {
				obj.shopWindowOpenFlg = true;
	      		obj.shop_mc.gotoAndStop(1);
	      		obj.shop_mc.s1.visible = false;
			    obj.shop_mc.s2.visible = false;
			    obj.shop_mc.s3.visible = false;
			    obj.shop_mc.s4.visible = false;
			    obj.shop_mc.s5.visible = false;
			    obj.shop_mc.s6.visible = false;
			    obj.shopTimeooutId = setTimeout(displayShopItems, 50, obj);
	      		addShopListener(obj);
	      		displayPowerShop(obj);
			} else if(event.target.parent.name == "button_menu_mc") {
				obj.menuWindowOpenFlg = true;
				obj.menu_mc.gotoAndStop(1);
	      		obj.menu_mc.g.gotoAndStop(0);
	      		obj.menu_mc.passText.text = obj.cegPassword;
	      		addMenuListener(obj);
	      		//icon設定
	      		obj.galleryId = setTimeout(setGallery, 50, obj);
	      		
			} else if(event.target.parent.name == "button_save_mc") {
				saveValueLocalAndServer(obj);
				//任意押下の場合は広告リロードさせない
	      		//reloadFooter(obj);
	      		//displayInterItem(obj);
			}
		}
	}
}

//アリスのリスナー解除
function removeCharaListener(obj) {
	obj.chara_mc.removeEventListener('click', obj, false);
	obj.chara_mc.removeEventListener('touchstart', obj, false);
	obj.button_shop_mc.removeEventListener('click', obj, false);
	obj.button_shop_mc.removeEventListener('touchstart', obj, false);
	obj.button_menu_mc.removeEventListener('click', obj, false);
	obj.button_menu_mc.removeEventListener('touchstart', obj, false);	
	obj.dummy3.removeEventListener('click', obj, false);
	obj.dummy3.removeEventListener('touchstart', obj, false);
}

//アリスタッチ時処理
function touchChara(obj) {
	obj.clickPointNumber ++;
	if(obj.clickPointNumber > 4) obj.clickPointNumber = 1;
	//ポイントGET
	var getPt = 0;
	if(obj.ability) {
		getPt = obj.clickPower * 10;
	} else {
		getPt = obj.clickPower;
	}
	obj.score += parseInt(getPt);
	if(obj.score >= COUNT_STOP) obj.score = COUNT_STOP;
	setNumberMc9(obj.record_score_mc, obj.score);
	setNumberMc(eval("obj.click_point_mc" + obj.clickPointNumber + ".n"), getPt);
	eval("obj.click_point_mc" + obj.clickPointNumber).visible = true;
	eval("obj.click_point_mc" + obj.clickPointNumber).gotoAndPlay(0);

	//レコード
	if(obj.score > obj.recordScore) obj.recordScore = obj.score;
	setAlice(obj);
}

//メニューのリスナー
function addMenuListener(obj) {
	obj.menu_mc.button_close_mc.addEventListener('click', obj, false);
	obj.menu_mc.button_close_mc.addEventListener('touchstart', obj, false);

	//ギャラリー
	obj.menu_mc.g1.addEventListener('click', obj, false);
	obj.menu_mc.g1.addEventListener('touchstart', obj, false);
	obj.menu_mc.g2.addEventListener('click', obj, false);
	obj.menu_mc.g2.addEventListener('touchstart', obj, false);
	obj.menu_mc.g3.addEventListener('click', obj, false);
	obj.menu_mc.g3.addEventListener('touchstart', obj, false);
	obj.menu_mc.g4.addEventListener('click', obj, false);
	obj.menu_mc.g4.addEventListener('touchstart', obj, false);
	obj.menu_mc.g5.addEventListener('click', obj, false);
	obj.menu_mc.g5.addEventListener('touchstart', obj, false);
	obj.menu_mc.g6.addEventListener('click', obj, false);
	obj.menu_mc.g6.addEventListener('touchstart', obj, false);
	obj.menu_mc.g7.addEventListener('click', obj, false);
	obj.menu_mc.g7.addEventListener('touchstart', obj, false);
	obj.menu_mc.g8.addEventListener('click', obj, false);
	obj.menu_mc.g8.addEventListener('touchstart', obj, false);

	//ツイート
	obj.menu_mc.btn_tweet_mc.addEventListener('click', obj, false);
	obj.menu_mc.btn_tweet_mc.addEventListener('touchstart', obj, false);

	obj.menu_mc.dummy_mc.addEventListener('click', obj, false);
	obj.menu_mc.dummy_mc.addEventListener('touchstart', obj, false);

	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "button_close_mc") {
	      		//クローズ
	      		removeMenuListener(obj);
	      		obj.menu_mc.gotoAndStop(0);
	      		addCharaListener(obj);
	      		obj.menuWindowOpenFlg = false;
			} else if(event.target.parent.name == "btn_tweet_mc") {
	      		//ツイート
	      		onTweet(obj);
			} else if(GALLERYITEM_REGEXP.test(event.target.parent.name)) {
				//ギャラリータッチ	
				onGallery(obj, Number(event.target.parent.name.substr(1)));
			}
		}
	}
}

//メニューのリスナー解除
function removeMenuListener(obj) {
	obj.menu_mc.button_close_mc.removeEventListener('click', obj, false);
	obj.menu_mc.button_close_mc.removeEventListener('touchstart', obj, false);
	//ギャラリー
	obj.menu_mc.g1.removeEventListener('click', obj, false);
	obj.menu_mc.g1.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g2.removeEventListener('click', obj, false);
	obj.menu_mc.g2.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g3.removeEventListener('click', obj, false);
	obj.menu_mc.g3.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g4.removeEventListener('click', obj, false);
	obj.menu_mc.g4.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g5.removeEventListener('click', obj, false);
	obj.menu_mc.g5.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g6.removeEventListener('click', obj, false);
	obj.menu_mc.g6.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g7.removeEventListener('click', obj, false);
	obj.menu_mc.g7.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g8.removeEventListener('click', obj, false);
	obj.menu_mc.g8.removeEventListener('touchstart', obj, false);

	obj.menu_mc.dummy_mc.removeEventListener('click', obj, false);
	obj.menu_mc.dummy_mc.removeEventListener('touchstart', obj, false);

}

//ショップのリスナー
function addShopListener(obj) {
	obj.shop_mc.button_close_mc.addEventListener('click', obj, false);
	obj.shop_mc.button_close_mc.addEventListener('touchstart', obj, false);
	//アイテム
	obj.shop_mc.s1.addEventListener('click', obj, false);
	obj.shop_mc.s1.addEventListener('touchstart', obj, false);
	obj.shop_mc.s2.addEventListener('click', obj, false);
	obj.shop_mc.s2.addEventListener('touchstart', obj, false);
	obj.shop_mc.s3.addEventListener('click', obj, false);
	obj.shop_mc.s3.addEventListener('touchstart', obj, false);
	obj.shop_mc.s4.addEventListener('click', obj, false);
	obj.shop_mc.s4.addEventListener('touchstart', obj, false);
	obj.shop_mc.s5.addEventListener('click', obj, false);
	obj.shop_mc.s5.addEventListener('touchstart', obj, false);
	obj.shop_mc.s6.addEventListener('click', obj, false);
	obj.shop_mc.s6.addEventListener('touchstart', obj, false);

	obj.shop_mc.dummy_mc.addEventListener('click', obj, false);
	obj.shop_mc.dummy_mc.addEventListener('touchstart', obj, false);

	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "button_close_mc") {
	      		//クローズ
	      		removeShopListener(obj);
	      		obj.shop_mc.gotoAndStop(0);
	      		addCharaListener(obj);
	      		displayItemCounts(obj);
	      		obj.shopWindowOpenFlg = false;
			} else if(SHOPITEM_REGEXP.test(event.target.parent.name)) {
				buyShopItem(obj, Number(event.target.parent.name.substr(1)));
			}
		}
	}
}

//ショップのリスナー解除
function removeShopListener(obj) {
	obj.shop_mc.button_close_mc.removeEventListener('click', obj, false);
	obj.shop_mc.button_close_mc.removeEventListener('touchstart', obj, false);
	//アイテム
	obj.shop_mc.s1.removeEventListener('click', obj, false);
	obj.shop_mc.s1.removeEventListener('touchstart', obj, false);
	obj.shop_mc.s2.removeEventListener('click', obj, false);
	obj.shop_mc.s2.removeEventListener('touchstart', obj, false);
	obj.shop_mc.s3.removeEventListener('click', obj, false);
	obj.shop_mc.s3.removeEventListener('touchstart', obj, false);
	obj.shop_mc.s4.removeEventListener('click', obj, false);
	obj.shop_mc.s4.removeEventListener('touchstart', obj, false);
	obj.shop_mc.s5.removeEventListener('click', obj, false);
	obj.shop_mc.s5.removeEventListener('touchstart', obj, false);
	obj.shop_mc.s6.removeEventListener('click', obj, false);
	obj.shop_mc.s6.removeEventListener('touchstart', obj, false);

	obj.shop_mc.dummy_mc.removeEventListener('click', obj, false);
	obj.shop_mc.dummy_mc.removeEventListener('touchstart', obj, false);
}

//ツイートボタン
function onTweet(obj) {
	var tweetStr = "";
	tweetStr += "https://twitter.com/intent/tweet?related=odm&source=tweetbutton&text=";
	tweetStr += "%23催眠アリスクリッカー";
	tweetStr += "%20記録:" + obj.recordScore + "催眠ポイント";
	
	if(obj.countStopFlg) {
		tweetStr += "%20" + "催眠アリスクリッカーをカンストさせました。";
	} else if(obj.recordScore >= GALLERY_POINTS[7]) {
		tweetStr += "%20" + "完全催眠完了！催眠アリスクリッカーをクリアしました。";
	}
	//カンスト
	tweetStr += "%20https://printdora-s3-files.s3-ap-northeast-1.amazonaws.com/3/alice_clicker.html";
	
	open( tweetStr, "_blank" ) ;
	//window.location = tweetStr;
}

//アカウント変更後
function responseChangeCegAccount(name, pass, session_key, obj) {
	//データ取得
	obj.cegUserName = name;
	obj.cegPassword = pass;
	obj.name_txt.text = "@" + obj.cegUserName;
	loadValue(CEG_AID, session_key, obj);
}

//アカウント変更エラー
function errorChangeCegAccount(obj) {
	window.alert("エラーです。通信状況とパスワードをご確認ください。");
}

function passerrorChangeCegAccount(obj) {
	window.alert("パスワードエラーです。Iとlなど似た文字にご注意ください。");
}

function responseSaveValue(obj) {
	//window.alert("保存しました。");
	if(obj.autoSaveFlg) {
		obj.autoSaveFlg = false;
		obj.save_alert_mc.gotoAndPlay(26);
	} else {
		obj.save_alert_mc.gotoAndPlay(1);
	}
	
}

function responseLoadValue(res, obj) {
	obj.gameData = JSON.parse(res);
	//アイテム数、ポイント
	obj.score = Number(obj.gameData["score"]);
	obj.recordScore   = Number(obj.gameData["rscore"]);

	obj.itemCounts[1] = obj.gameData["item1"];
	obj.itemCounts[2] = obj.gameData["item2"];
	obj.itemCounts[3] = obj.gameData["item3"];
	obj.itemCounts[4] = obj.gameData["item4"];
	obj.itemCounts[5] = obj.gameData["item5"];
	obj.itemCounts[6] = obj.gameData["item6"];

	//ローカル保存
	saveValueLocal(obj);

	//現在の催眠パワー
	obj.autoPower = getAutoPower(obj.itemCounts);

	//現在のクリック催眠パワー
	obj.clickPower = getClickPower(obj.itemCounts);

	//ポイント
	//obj.recordScore = obj.score;
	setNumberMc9(obj.record_score_mc, obj.score);
	
	window.alert("データを切り替えました");
}

function errorSaveValue(obj) {

}

function errorLoadValue(obj) {
	
}

function onGallery(obj, galleryNumber) {
	if(GALLERY_POINTS[galleryNumber-1] > obj.recordScore) return;
		
	//ギャラリーを表示
	obj.menu_mc.g.gotoAndStop(galleryNumber);

	//リスナー登録
	addGalleryListener(obj);

	//メニューリスナー削除
	removeMenuListener(obj);
}

function addGalleryListener(obj) {
	obj.menu_mc.g.button_close_mc.addEventListener('click', obj, false);
	obj.menu_mc.g.button_close_mc.addEventListener('touchstart', obj, false);
	obj.menu_mc.g.dummy_mc.addEventListener('click', obj, false);
	obj.menu_mc.g.dummy_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "button_close_mc") {

	      		obj.menu_mc.g.gotoAndStop(0);
	      		removeGalleryListener(obj);
	      		addMenuListener(obj);
			} else {
				//dummy
			}
		}
	}
}

function removeGalleryListener(obj) {
	obj.menu_mc.g.button_close_mc.removeEventListener('click', obj, false);
	obj.menu_mc.g.button_close_mc.removeEventListener('touchstart', obj, false);
	obj.menu_mc.g.dummy_mc.removeEventListener('click', obj, false);
	obj.menu_mc.g.dummy_mc.removeEventListener('touchstart', obj, false);
}

//アイテムリスナー
function addPopItemListener(obj) {
	obj.pop_item_mc.pop_dummy_mc.addEventListener('click', obj, false);
	obj.pop_item_mc.pop_dummy_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "pop_dummy_mc") {
	      		//ポップアイテム処理
	      		obj.pop_item_mc.gotoAndStop(0);
	      		removePopItemListener(obj);
	      		addCharaListener(obj);
	      		if(obj.itemKind == 1) {
	      			//30秒間クリックパワー10倍
	      			obj.ability = true;
	      			obj.save_alert_mc.gotoAndPlay(50);
	      			obj.abilityTime = 30;
	      			obj.ablityId = setTimeout(abilityTimeDecre, 1000, obj);
	      			obj.ablityVisibleId = setTimeout(abilityTimeVisible, 50, obj);
	      			obj.itemCounter = 0;
	      		} else if(obj.itemKind == 2) {
	      			//（クリックパワー＋自動パワー）* 10
	      			obj.save_alert_mc.gotoAndPlay(95);
	      			var getPt = (obj.autoPower + obj.clickPower)*100;
	      			obj.score += parseInt(getPt);
					if(obj.score >= COUNT_STOP) obj.score = COUNT_STOP;
					setNumberMc9(obj.record_score_mc, obj.score);
					obj.itemCounter = 0;
					obj.itemKind2TimeOutId = setTimeout(itemKind2TimeOut, 50, obj, getPt);
	      		}
	      		if(obj.score > obj.recordScore) obj.recordScore = obj.score;
				setAlice(obj);
			}
		}
	}
}

function itemKind2TimeOut(obj, getPt) {
	//setNumberMc(obj.save_alert_mc.getPtMc, getPt);
	setNumberMc9(obj.save_alert_mc.getPtMc, getPt);
}

function abilityTimeVisible(obj) {
	obj.ability_time_mc.visible = true;
	setNumberMc3(obj.ability_time_mc, obj.abilityTime);
}

//アイテムのリスナー解除
function removePopItemListener(obj) {
	obj.pop_item_mc.removeEventListener('click', obj, false);
	obj.pop_item_mc.removeEventListener('touchstart', obj, false);

}
