//3ケタにする
function getCommaByNum(num) {
    var result = "";
    var numstr = String(num);
    for(var i=0; i<numstr.length; i++) {
        if(i%3==0 && i!=0) result = ',' + result;
        result = numstr.charAt(numstr.length - i - 1) + result;
    }
    return result;
}

//maxを含まない
function getRandomInt(max) {
	return Math.floor(Math.random() * Math.floor(max));
}

String.prototype.lengthB = function() {
    var len = 0;
    for (var i = 0; i < this.length; i++) {
    if (this.charAt(i).isMultibyte()) {
    len += 2;
    } else {
    len += 1;
    }
    }
    return len;
}

String.prototype.substrB = function() {
    var fromByte = arguments[0];
    var retByte = arguments[1];

    // 開始位置の検索
    var len = 0;
    var i;
    for (i = 0; fromByte > len; i++) {
        if (this.charAt(i).isMultibyte()) {
            len += 2;
        } else {
            len += 1;
        }
    }
    var from = i;

    len = 0;
    var retLen = 0;
    while(retByte > len) {
        if (this.charAt(i).isMultibyte()) {
            len = len + 2;
        } else {
            len = len + 1;
        }
        retLen++;
        i++;
    }
    return this.substr(from, retLen);
}
String.prototype.isMultibyte = function() {
    var c = this.charCodeAt(0);
    // 半角の範囲
    // Unicode : 0x0 ～ 0x80, 0xf8f0, 0xff61 ～ 0xff9f, 0xf8f1 ～ 0xf8f3
    if ((c >= 0x0 && c <= 0x80) || (c == 0xf8f0) || (c >= 0xff61 && c <= 0xff9f) || (c >= 0xf8f1 && c <= 0xf8f3)) {
        return false;
    } else {
        return true;
    }
}

function getAdText() {
	if(navigator.userAgent.match(/(iPhone|iPad|iPod|Android)/i)) {
		//sp
		return AD2;
	} else {
		//pc
		return AD1;
	}
}

function getInterAdText() {
    var result = "";
    result += "<script src='https://fam-ad.com/ad/js/fam-tagify.min.js'></script>";
    result += "<div id= 'div_fam_async_220867_100'>";
    result += "<script language='javascript'><!--";
    result += "fam_js_async('https://fam-ad.com/ad', '_site=65000&_loc=220867&_mstype=100&_width=&_height=');";
    result += "//--></script>";
    result += "</div>";
   return result;
}

//サウンドを一旦読み込みます
function loadSound() {
    var audioTimes = new Array();
    var audios = new Array();
    for(var i=0; i<SOUND_FILE.length; i++) {
        var soundFileName = SOUND_FILE[i];
        audios[i] = new Audio();
        audios[i].src = "sound/" + soundFileName + ".mp3"; 
        audios[i].load();
        audios[i].filename = soundFileName;
        if(i==0) audios[i].loop = true;
    }
    return audios;
}

//記録の表示
function displayRecord(record_mc) {
    var score = localStorage.getItem("aliceclicker_recordsocre");
    score = Number(score);
    if(score == undefined || score == null || score==0 || isNaN(score)) {
        localStorage.setItem("aliceclicker_recordsocre", 0);
        score = 0;
        setNumberMc9(record_mc, 0);
    } else {
        setNumberMc9(record_mc, score);
    }
    return score;
}

//3桁
function setNumberMc3(numberMc, number) {
    if(number<0) number = 0;
    var d3 = Math.floor(number/100);
    var d2 = Math.floor((number - d3*100) / 10);
    var d1 = number - d3*100 - d2*10;

    if(d3 == 0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
}

//6桁
function setNumberMc(numberMc, number) {
    if(number<0) number = 0;
    var d6 = Math.floor(number/100000);
    var d5 = Math.floor((number - d6*100000) / 10000);
    var d4 = Math.floor((number - d6*100000 - d5*10000) / 1000);
    var d3 = Math.floor((number - d6*100000 - d5*10000 - d4*1000) / 100);
    var d2 = Math.floor((number - d6*100000 - d5*10000 - d4*1000 - d3*100) / 10);
    var d1 = number - d6*100000 - d5*10000 - d4*1000 - d3*100 - d2*10;

    if(d6 == 0) {
        numberMc.unit6.gotoAndStop(11);
    } else {
        numberMc.unit6.gotoAndStop(d6+1);
    }
    if(d5 == 0 && d6==0) {
        numberMc.unit5.gotoAndStop(11);
    } else {
        numberMc.unit5.gotoAndStop(d5+1);
    }
    if(d4 == 0 && d5==0 && d6==0) {
        numberMc.unit4.gotoAndStop(11);
    } else {
        numberMc.unit4.gotoAndStop(d4+1);
    }
    if(d3 == 0 && d4==0 && d5==0 && d6==0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0 && d4==0 && d5==0 && d6==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
    if(d6==0 && d5==0 && d4==0) {
        numberMc.c1.visible = false;
    } else {
        numberMc.c1.visible = true;
    }
}

//9桁
function setNumberMc9(numberMc, number) {
    if(number<0) number = 0;
    
    var d9 = Math.floor(number/100000000);
    var d8 = Math.floor((number - d9*100000000) / 10000000);
    var d7 = Math.floor((number - d9*100000000 - d8*10000000) / 1000000);
    var d6 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000) / 100000);
    var d5 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000) / 10000);
    var d4 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000) / 1000);
    var d3 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000) / 100);
    var d2 = Math.floor((number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000 - d3*100) / 10);
    var d1 = number - d9*100000000 - d8*10000000 - d7*1000000 - d6*100000 - d5*10000 - d4*1000 - d3*100 - d2*10;

    if(d9 == 0) {
        numberMc.unit9.gotoAndStop(11);
    } else {
        numberMc.unit9.gotoAndStop(d9+1);
    }
    if(d8 == 0 && d9==0) {
        numberMc.unit8.gotoAndStop(11);
    } else {
        numberMc.unit8.gotoAndStop(d8+1);
    }
    if(d7 == 0 && d8==0 && d9==0) {
        numberMc.unit7.gotoAndStop(11);
    } else {
        numberMc.unit7.gotoAndStop(d7+1);
    }
    if(d6 == 0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit6.gotoAndStop(11);
    } else {
        numberMc.unit6.gotoAndStop(d6+1);
    }
    if(d5 == 0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit5.gotoAndStop(11);
    } else {
        numberMc.unit5.gotoAndStop(d5+1);
    }
    if(d4 == 0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit4.gotoAndStop(11);
    } else {
        numberMc.unit4.gotoAndStop(d4+1);
    }
    if(d3 == 0 && d4==0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0 && d4==0 && d5==0 && d6==0 && d7==0 && d8==0 && d9==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
    if(d9==0 && d8==0 && d7==0 && d6==0 && d5==0 && d4==0) {
        numberMc.c1.visible = false;
        numberMc.c2.visible = false;
    } else if(d9==0 && d8==0 && d7==0) {
        numberMc.c1.visible = true;
        numberMc.c2.visible = false;
    } else {
        numberMc.c1.visible = true;
        numberMc.c2.visible = true;
    }
}

//トークン取得
function kickGetToken(obj) {
    getCegToken(CEG_AID, obj.cegSessionKey, obj);
}

function responseGetCegToken(token, obj) {
    obj.token = token;
    obj.tokenmiss = 0;
}

function errorGetCegToken(obj) {
    obj.tokenmiss ++;
    if(obj.tokenmiss > 5) window.alert("通信のできる場所でプレイしてくださいね。");
}

//スコア送信
function ajaxSendPoint(obj, pt, sk, tk, pl) {
    $.ajax(URL_SENDPOINT, {
        type: 'post',
        data: { "aid":CEG_AID , "pt": pt, "sk": sk, "tk":tk, "pl":pl },
        dataType: 'json',
        timeout: 1000,
      }
    )
    // 通信成功
    .done(function(res) {
        if(res["dailyRank"] != undefined) {
            obj.daily_ranking_mc.gotoAndStop(1);
            setNumberMc3(obj.daily_ranking_mc.rank_mc, res["dailyRank"]);
            obj.dailyRank = res["dailyRank"];
            obj.rankingFlg = true;
        }
        if(res["totalRank"] != undefined) {
            obj.total_ranking_mc.gotoAndStop(1);
            setNumberMc3(obj.total_ranking_mc.rank_mc, res["totalRank"]);
            obj.totalRank = res["totalRank"];
        }
        sendpointAfter(obj);
    })
    // 通信失敗(タイムアウトまたはサーバエラー)
    .fail(function(XMLHttpRequest, textStatus, errorThrown) {
        document.getElementById("commentTextArea").value = "通信失敗しました。通信のできる場所でプレイしてくださいね。";
        //再通信ボタン表示
        addLastButtons(obj);
        obj.last_buttons.gotoAndStop(2);
        displayInterAd(obj);
    });
}

function sendpointAfter(obj) {
    //タイムアップキック
    obj.timeupId = setTimeout(kickTimeup, 2000, obj);
    //ボタン表示
    obj.last_buttons.gotoAndStop(1);
    obj.addLastButtonId = setTimeout(addLastButtons, 500, obj);
    //トークンインターバル削除
    clearInterval(obj.intervalTokenId);

    displayInterAd(obj);
}

//音を出します
function playsound(obj, soundKey) {
    if(obj.soundFlg != FLG_ON) return;
    if(soundKey==0) {
        obj.audios[soundKey].volume = 0.4;
    }
    obj.audios[soundKey].play();
}

function stopsound(obj, soundKey) {
    obj.audios[soundKey].pause() ;
    obj.audios[soundKey].currentTime = 0 ;
}

//自動催眠ポイント
function getAutoPower(itemCounts) {
    var result = 0;
    result += itemCounts[1] * 1;
    result += itemCounts[2] * 0;
    result += itemCounts[3] * 15;
    result += itemCounts[4] * 0;
    result += itemCounts[5] * 50;
    result += itemCounts[6] * 300;
    if(result > POWER_COUNT_STOP) result = POWER_COUNT_STOP;
    return result;
}

//クリック催眠ポイント
function getClickPower(itemCounts) {
    var result = 1;
    result += itemCounts[1] * 0;
    result += itemCounts[2] * 1;
    result += itemCounts[3] * 0;
    result += itemCounts[4] * 14;
    result += itemCounts[5] * 5;
    result += itemCounts[6] * 150;
    if(result > POWER_COUNT_STOP) result = POWER_COUNT_STOP;
    return result;
}

function resZeroUndefined(value) {
    if(value == undefined || value == null || value==0 || isNaN(value)) return 0;
    return value;
}

function saveValueLocal(obj) {
    //ローカル保存
    localStorage.setItem("aliceclicker_recordsocre", obj.score);
    localStorage.setItem("aliceclicker_hirecordsocre", obj.recordScore);
    for(var i=1; i<=6; i++) {
        localStorage.setItem("aliceclicker_item_count"+i, obj.itemCounts[i]);
    }
}

function saveValueLocalAndServer(obj) {
    saveValueLocal(obj);
    //サーバへ保存
    var valueobj = new Object();
    valueobj["value1"] = "dummy";
    valueobj["score"] = obj.score;
    valueobj["rscore"] = obj.recordScore;
    for(var i=1; i<=6; i++) {
        valueobj["item"+i] = obj.itemCounts[i];
    }
    var value = JSON.stringify(valueobj);

    //#dl_version
    responseSaveValue(obj);
    //saveValue(CEG_AID, obj.cegSessionKey, value, obj);
}

//ショップアイテムを表示します
function displayShopItems(obj) {
    for(var i=1; i<=ITEM_COUNT; i++) {
        eval("obj.shop_mc.s" + i + ".itemNameText").text = ITEM_NAME[i-1];
        eval("obj.shop_mc.s" + i + ".icon_mc").gotoAndStop(i-1);
        displayShopItemOpen(obj, i);
        eval("obj.shop_mc.s" + i).visible = true;
    }
}

//Pt変更時のショップアイテムを表示します
function displayShopItemsForPoint(obj) {
    for(var i=1; i<=ITEM_COUNT; i++) {
        displayShopItemOpen(obj, i);
    }
}

//価格を取得します。　どのアイテムをいくつ所持した状態か
function getPriceByItemIdAndCount(itemId, obj) {
    return obj.itemCounts[itemId] * ITEM_PRICE_A[itemId-1] + ITEM_PRICE_B[itemId-1];
}

function displayShopItemOpen(obj, i) {
    //価格
    eval("obj.shop_mc.s" + i + ".priceText").text = getCommaByNum(getPriceByItemIdAndCount(i, obj)) + " Pt"; 

    //開放条件
    if(obj.itemCounts[i] >= ITEM_SOLD_COUNT) {
        //売り切れ
        eval("obj.shop_mc.s" + i).gotoAndStop(3);
    } else if(i>=3 && obj.itemCounts[i-3] < ITEM_OPEN[i-1]) {
        //開放されてない
        eval("obj.shop_mc.s" + i).gotoAndStop(2);
        eval("obj.shop_mc.s" + i + ".itemNameText").text = "？？？";
        eval("obj.shop_mc.s" + i + ".priceText").text = "？？？ Pt";
    } else if(getPriceByItemIdAndCount(i, obj) > obj.score) {
        //開放されているが、Ptがたらない
        eval("obj.shop_mc.s" + i).gotoAndStop(1);
    } else {
        eval("obj.shop_mc.s" + i).gotoAndStop(0);
    }
}

